unit spiel;

interface

uses vektors, Windows;

type
  TPlayer = record
              pos  : TVektor;
              hold : set of byte;
              hat  : byte;
              name : string;
              wait : integer;
              ping : double;
              lastevent : integer;
            end;
  TEffekt = record
              pos: TVektor;
              art: byte;
              zeit: integer; {0..gzeit; -1 fr aus}
              gzeit: integer;
            end;
  TChangePlayerData= record
                        MessageType : DWORD;
                        namen : array[0..5] of string[80];
                     end;
  TStartData = record
                 MessageType : DWORD;
                 rseed : longint;
               end;
  TPauseData = record
                 MessageType : DWORD;
                 time : integer;
               end;
  TPingData = record
                MessageType : DWord;
                time : integer;
                zeit : double;
                von : string[40];
              end;
  TTakeData = record
            MessageType : DWORD;
            time : integer;
            pos: TVektor;
          end;
  TTrowData = record
            MessageType : DWORD;
            time : integer;
            pos: TVektor;
          end;
  PEreignis = ^TEreignis;
  TEreignis = record
                MessageType : DWord;
                time : integer;
                from : integer;
                next : PEreignis;
              case byte of
                0: (pos : TVektor;)
              end;


const
      maxspeed = 5;
      maxk = 8;
      starke = 50;

      mChangePlayer = 0;
      mStart = 1;
      mTake = 2;
      mTrow = 3;
      mPause = 4;
      mPing = 5;

var
  kugeln : array[-1..maxk] of TKugel;
  kkugel : ^TKugel;

  mx,my : integer;
  player : array[0..5] of TPlayer;
  effekte : array[0..30] of TEffekt;
  ereignis : PEreignis;
  szeit : integer;
  startlist : array[0..5] of boolean;
  punkte : record h,c: integer; end;
  ich : integer;
  {Ablaufsteuerung}
  verz: integer;
  pause : boolean;
  pzeit : integer;
  useki : boolean;

  function findname(st: string):integer;
  procedure starteffekt(_pos: TVektor; _art: Byte);
  function createereignis(typ, from, _time: integer;ve: TVektor): boolean;
  procedure ereignisstart;
  procedure spielstart;
  procedure movekugel(var k: TKugel);
  procedure kugelstos(var k1,k2 : TKugel);
  procedure hitkugeln;


implementation

uses main, sysutils;

const  stdkugeln :array[0..3] of TKugel = ((pos:(x:000;y:  0);speed:(x:0;y:0);radius:5;g:10000),
                                           (pos:(x:550;y:  0);speed:(x:0;y:0);radius:5;g:10000),
                                           (pos:(x:000;y:500);speed:(x:0;y:0);radius:5;g:10000),
                                           (pos:(x:550;y:500);speed:(x:0;y:0);radius:5;g:10000));


function findname(st: string):integer;
var int1 : integer;
begin
  for int1 := 0 to 5 do if player[int1].name = st then begin
    findname := int1;
    exit;
  end;
end;

procedure starteffekt(_pos: TVektor; _art: Byte);
var int1 : integer;
begin
  for int1 := 0 to 30 do with effekte[int1] do if zeit = -1 then begin
    pos := _pos;
    art := _art;
    zeit := 0;
    gzeit := 30;
    exit;
  end;
end;

function createereignis(typ, from, _time: integer;ve: TVektor): boolean;
var er, er2: PEreignis;
label neu;
begin
  er := ereignis;
  if er = nil then begin new(er2);ereignis:= er2; ereignis^.next := nil; goto neu; end;
  while (er^.next <> nil) and (er^.next.time<_time) do er := er^.next;
  new(er2);
  er2^.next:= er^.next;
  er^.next := er2;
  neu:
  er2^.MessageType := typ;
  er2^.from := from;
  er2^.time := _time;
  er2^.pos := ve;
  if _time < szeit then result := false else result := true;
end;

  procedure wurf(var player: Tplayer; nach : TVektor);
  var int1 : integer;
  begin
    with player do
      for int1 := 0 to maxk do if int1 in hold then begin
        hold := hold - [int1];
        with kugeln[int1] do begin
          speed := vsub(nach,player.pos);
          speed := vmul(speed,5/betrag(speed));
          pos := player.pos;
          radius := 15;
          g := radius;
          dec(hat);
          exit;
        end;
      end;
  end;

  procedure nimm(var player: TPlayer;von: TVektor);
  var int1,int2: integer;
  begin
    for int1 := 0 to maxk do
      with kugeln[int1] do
        if (pos.x >-10) and (betrag(vsub(von,pos))<10) and (betrag(speed)<2)
           and (player.hat < maxk-3) then begin
          starteffekt(von,1);
          player.hold := player.hold + [int1];
          pos.x := -11;
          speed := vektor(0,0);
          inc(player.hat);
          if player.name <> 'PC' then form1.dxwavelist1.items[0].play(false);
        end;
  end;

procedure ereignisstart;
var er : Pereignis;
begin
  while (ereignis<>nil) and (ereignis^.time < szeit) do begin
    with ereignis^ do
      case messagetype of
        mTake : nimm(player[from],pos);
        mTrow : wurf(player[from],pos);
        mPause : pause := not pause;
      end;
    er := ereignis;
    ereignis := ereignis^.next;
    dispose(er);
  end;
end;

procedure spielstart;
var int1 : integer;
begin
  ereignis := nil;
  kkugel^.pos := vektor(250,275);
  kkugel^.speed:= vektor(0,0);
  for int1 := 6 to maxk do with kugeln[int1] do begin
    pos := vektor(random(400)+50,random(450)+50);
    speed := vektor(random(100)/100-0.5,random(100)/100-0.5);
    radius := 15;
    g := 100;
  end;
  for int1 := 0 to 5 do with player[int1] do begin
    kugeln[int1].pos.x := -11;
    hold := [int1];
    hat := 1;
    wait := (starke * (punkte.h+punkte.c+ich) mod 6) div 6;
    lastevent := verz;
  end;
  szeit := 0;
  pzeit := 0;
  verz := 30;
  form1.label9.Caption:= 'Verzgerung : 30';
  pause := false;
end;

procedure movekugel(var k: TKugel);
begin
  with k do begin
    if pos.x < -10 then exit;
    pos := vadd(pos,speed);
    speed := vmul(speed,0.995);
  end;
end;

procedure kugelstos(var k1,k2 : TKugel);
var u,k_1,k_2,s1,s2, l1, l2 : TVektor;
    n : double;
    re1,re2 : double;
begin
  re1 := d(k1.pos,k2.pos);
  u := vsub(k2.pos,k1.pos);     {u = k1->k2}
  u := vdiv(u,betrag(u));
  if re1 < k1.radius+k2.radius then begin
    if (addr(k1)= kkugel) or (addr(k2)= kkugel) then form1.dxwavelist1.items[1].play(false)
    else form1.dxwavelist1.items[2].play(false);
    s1 := k1.speed; s2 := k2.speed;
    k_1 := vmul(u, s1.x*u.x+s1.y*u.y);
    k_2 := vmul(u, s2.x*u.x+s2.y*u.y);
    l1 := vsub(s1,k_1);
    l2 := vsub(s2,k_2);
    re2 := k1.g+k2.g;
    k1.speed := vdiv(vadd(vmul(k_1,
                               k1.g),
                          vmul(vsub(vmul(k_2, 2), k_1),
                               k2.g)),
                     re2);
    k2.speed := vdiv(vadd(vmul(k_2,
                               k2.g),
                          vmul(vsub(vmul(k_1, 2), k_2),
                               k1.g)),
                     re2);
    k1.speed := vmul(vneg(u),betrag(k1.speed));
    k2.speed := vmul(u,betrag(k2.speed));
    k1.speed := vadd(l1,k1.speed);
    k2.speed := vadd(l2,k2.speed);
  end;
end;

procedure hitkugeln;
var int1,int2 : integer;
    re1,re2,re3 : double;
    ve1,ve2 : TVektor;
    tempk: TKugel;
    er : PEreignis;
begin
  for int1 := -1 to maxk do with kugeln[int1] do begin
    if (pos.x-radius < 10) then speed.x := abs(speed.x) else
      if (pos.x+radius > 490) then speed.x := -abs(speed.x);
    if (int1 <> -1) then begin
      if (pos.y-radius < 10) then speed.y := abs(speed.y) else
        if (pos.y+radius > 540) then speed.y := -abs(speed.y);
    end;
    for int2 := int1+1 to maxk do if kugeln[int1].pos.x >= -10 then
      kugelstos(kugeln[int1],kugeln[int2]);
  end;
  for int1 := 0 to 3 do begin
    tempk := stdkugeln[int1];
    kugelstos(kugeln[-1],tempk);
  end;
  if (kkugel.pos.y < 0) or (kkugel.pos.y > 550) then begin
    if kkugel.pos.y < 0 then inc(punkte.h);
    if kkugel.pos.y > 0 then inc(punkte.c);
    form1.label3.Caption:= inttostr(punkte.c);
    form1.label4.Caption:= inttostr(punkte.h);
    while ereignis <> nil do begin
      er := ereignis^.next;
      dispose(ereignis);
      ereignis := er;
    end;
    dispose(ereignis);
    SpielStart;
  end;
end;

end.
