unit vektors;

interface

type TVektor = record x,y: double; end;
     TKugel = Record
                pos, speed : TVektor;
                radius, g : double;
              end;

function vektor(x,y: double): TVektor;
function vadd(v1,v2 :TVektor): TVektor;
function vsub(v1,v2 :TVektor): TVektor;
function vmul(v1 :TVektor; r : double): TVektor;
function vdiv(v1 :TVektor; r : double): TVektor;
function vneg(v1: TVektor): TVektor;
function betrag(v1: TVektor) : double;
function d(k1,k2 : TVektor) : double;
function det(v1,v2 : TVektor) : double;

implementation

function vektor(x,y: double): TVektor;
begin
  vektor.x := x;
  vektor.y := y;
end;

function vadd(v1,v2 :TVektor): TVektor;
begin
  vadd.x := v1.x+v2.x;
  vadd.y := v1.y+v2.y;
end;

function vsub(v1,v2 :TVektor): TVektor;
begin
  vsub.x := v1.x-v2.x;
  vsub.y := v1.y-v2.y;
end;

function vmul(v1:TVektor; r : double): TVektor;
begin
  vmul.x := v1.x*r;
  vmul.y := v1.y*r;
end;

function vdiv(v1 :TVektor; r : double): TVektor;
begin
  vdiv.x := v1.x/r;
  vdiv.y := v1.y/r;
end;

function vneg(v1: TVektor): TVektor;
begin
  vneg.x := -v1.x;
  vneg.y := -v1.y;
end;

function betrag(v1: TVektor) : double;
begin
  betrag := sqrt(v1.x*v1.x+v1.y*v1.y);
end;

function d(k1,k2 : TVektor) : double;
begin
  d := betrag(vsub(k1,k2));
end;

function det(v1,v2 : TVektor) : double;
begin
  det := v1.x*v2.y - v1.y*v2.x;
end;

end.
